"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiFileBody = void 0;
const swagger_1 = require("@nestjs/swagger");
const buildSchemaObj = (props) => {
    const names = Array.isArray(props) ? !props ? ['file'] : props : [props];
    return names.reduce((o, key) => ({
        ...o, [key]: {
            type: 'string',
            format: 'binary'
        }
    }), {});
};
const ApiFileBody = (...fileName) => (target, propertyKey, descriptor) => {
    (0, swagger_1.ApiBody)({
        schema: {
            type: 'object',
            properties: buildSchemaObj(fileName)
        }
    })(target, propertyKey, descriptor);
};
exports.ApiFileBody = ApiFileBody;
//# sourceMappingURL=api-file-body.js.map